Index: uspace/app/taskbar-cfg/test/startmenu.c
===================================================================
--- uspace/app/taskbar-cfg/test/startmenu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar-cfg/test/startmenu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,274 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <async.h>
+#include <dispcfg.h>
+#include <dispcfg_srv.h>
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <str.h>
+#include <testdc.h>
+#include "../display-cfg.h"
+#include "../seats.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(seats);
+
+static const char *test_dispcfg_server = "test-dispcfg";
+static const char *test_dispcfg_svc = "test/dispcfg";
+
+/** Test dcfg_seats_create() and dcfg_seats_destroy() */
+PCUT_TEST(create_destroy)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+/** dcfg_seats_insert() inserts an entry into the seat list */
+PCUT_TEST(seats_insert)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	dcfg_seats_entry_t *entry = NULL;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_insert(seats, "Alice", 42, &entry);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(entry);
+
+	PCUT_ASSERT_STR_EQUALS("Alice", entry->name);
+	PCUT_ASSERT_INT_EQUALS(42, entry->seat_id);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+/** dcfg_seats_list_populate() populates seat list */
+PCUT_TEST(seats_list_populate)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	errno_t rc;
+	service_id_t sid;
+	test_response_t resp;
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_dispcfg_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_dispcfg_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_dispcfg_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_cfg_open(dcfg, test_dispcfg_svc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/*
+	 * dcfg_seat_list_populate() calls dispcfg_get_seat_list()
+	 * and dispcfg_get_seat_info()
+	 */
+	resp.rc = EOK;
+	resp.get_seat_list_rlist = calloc(1, sizeof(dispcfg_seat_list_t));
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_list_rlist);
+	resp.get_seat_list_rlist->nseats = 1;
+	resp.get_seat_list_rlist->seats = calloc(1, sizeof(sysarg_t));
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_list_rlist->seats);
+	resp.get_seat_list_rlist->seats[0] = 42;
+
+	resp.get_seat_info_rinfo = calloc(1, sizeof(dispcfg_seat_info_t));
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_info_rinfo);
+	resp.get_seat_info_rinfo->name = str_dup("Alice");
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_info_rinfo->name);
+
+	rc = dcfg_seats_list_populate(seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
+}
+
+/** dcfg_devices_insert() inserts an entry into the device list */
+PCUT_TEST(devices_insert)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	ui_list_entry_t *lentry;
+	dcfg_devices_entry_t *entry;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_devices_insert(seats, "mydevice", 42);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lentry = ui_list_first(seats->device_list);
+	PCUT_ASSERT_NOT_NULL(lentry);
+	entry = (dcfg_devices_entry_t *)ui_list_entry_get_arg(lentry);
+	PCUT_ASSERT_NOT_NULL(entry);
+
+	PCUT_ASSERT_STR_EQUALS("mydevice", entry->name);
+	PCUT_ASSERT_INT_EQUALS(42, entry->svc_id);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+/** dcfg_avail_devices_insert() inserts entry into available devices list */
+PCUT_TEST(avail_devices_insert)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	ui_list_entry_t *lentry;
+	dcfg_devices_entry_t *entry;
+	ui_select_dialog_t *dialog;
+	ui_select_dialog_params_t sdparams;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_select_dialog_params_init(&sdparams);
+	sdparams.caption = "Dialog";
+	sdparams.prompt = "Select";
+
+	rc = ui_select_dialog_create(seats->dcfg->ui, &sdparams, &dialog);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_avail_devices_insert(seats, dialog, "mydevice", 42);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lentry = ui_list_first(ui_select_dialog_list(dialog));
+	PCUT_ASSERT_NOT_NULL(lentry);
+	entry = (dcfg_devices_entry_t *)ui_list_entry_get_arg(lentry);
+	PCUT_ASSERT_NOT_NULL(entry);
+
+	PCUT_ASSERT_STR_EQUALS("mydevice", entry->name);
+	PCUT_ASSERT_INT_EQUALS(42, entry->svc_id);
+
+	ui_select_dialog_destroy(dialog);
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+PCUT_TEST(asgn_dev_list_populate)
+{
+}
+
+PCUT_TEST(avail_dev_list_populate)
+{
+}
+
+PCUT_TEST(seats_get_selected)
+{
+}
+
+PCUT_TEST(devices_get_selected)
+{
+}
+
+PCUT_TEST(seats_list_selected)
+{
+}
+
+PCUT_TEST(add_seat_clicked)
+{
+}
+
+PCUT_TEST(remove_seat_clicked)
+{
+}
+
+PCUT_TEST(add_seat_dialog_bok)
+{
+}
+
+PCUT_TEST(add_seat_dialog_bcancel)
+{
+}
+
+PCUT_TEST(add_seat_dialog_close)
+{
+}
+
+PCUT_TEST(add_device_clicked)
+{
+}
+
+PCUT_TEST(remove_device_clicked)
+{
+}
+
+PCUT_TEST(add_device_dialog_bok)
+{
+}
+
+PCUT_TEST(add_device_dialog_bcancel)
+{
+}
+
+PCUT_TEST(add_device_dialog_close)
+{
+}
+
+PCUT_EXPORT(seats);
Index: uspace/app/taskbar-cfg/test/taskbar-cfg.c
===================================================================
--- uspace/app/taskbar-cfg/test/taskbar-cfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar-cfg/test/taskbar-cfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <ui/ui.h>
+#include "../display-cfg.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(display_cfg);
+
+/** Test display_cfg_create() and display_cfg_destroy() */
+PCUT_TEST(create_destroy)
+{
+	display_cfg_t *dcfg;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	display_cfg_destroy(dcfg);
+}
+
+PCUT_EXPORT(display_cfg);
Index: uspace/app/taskbar-cfg/types/smeedit.h
===================================================================
--- uspace/app/taskbar-cfg/types/smeedit.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar-cfg/types/smeedit.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,75 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar-cfg
+ * @{
+ */
+/**
+ * @file Start menu entry edit dialog
+ */
+
+#ifndef TYPES_SMEEDIT_H
+#define TYPES_SMEEDIT_H
+
+#include <ui/checkbox.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/entry.h>
+#include <ui/pbutton.h>
+#include <ui/window.h>
+
+/** Start menu entry edit dialog */
+typedef struct smeedit {
+	/** Containing start menu configuration tab */
+	struct startmenu *startmenu;
+	/** Start menu entry or @c NULL if creating a new entry */
+	struct startmenu_entry *smentry;
+	/** Window */
+	ui_window_t *window;
+	/** Fixed layout */
+	ui_fixed_t *fixed;
+	/** 'Caption' label */
+	ui_label_t *lcaption;
+	/** Caption entry */
+	ui_entry_t *ecaption;
+	/** 'Command' label */
+	ui_label_t *lcmd;
+	/** Command entry */
+	ui_entry_t *ecmd;
+	/** Start in terminal checkbox */
+	ui_checkbox_t *cbterminal;
+	/** OK button */
+	ui_pbutton_t *bok;
+	/** Cancel button */
+	ui_pbutton_t *bcancel;
+} smeedit_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskbar-cfg/types/startmenu.h
===================================================================
--- uspace/app/taskbar-cfg/types/startmenu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar-cfg/types/startmenu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar-cfg
+ * @{
+ */
+/**
+ * @file Start menu configuration tab
+ */
+
+#ifndef TYPES_STARTMENU_H
+#define TYPES_STARTMENU_H
+
+#include <tbarcfg/tbarcfg.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/list.h>
+#include <ui/pbutton.h>
+#include <ui/tab.h>
+
+/** Start menu configuration tab */
+typedef struct startmenu {
+	/** Containing taskbar configuration */
+	struct taskbar_cfg *tbarcfg;
+	/** UI tab */
+	ui_tab_t *tab;
+	/** Fixed layout */
+	ui_fixed_t *fixed;
+	/** 'Start menu entries' label */
+	ui_label_t *entries_label;
+	/** List of start menu entries */
+	ui_list_t *entries_list;
+	/** New entry button */
+	ui_pbutton_t *new_entry;
+	/** Delete entry button */
+	ui_pbutton_t *delete_entry;
+	/** Edit entry button */
+	ui_pbutton_t *edit_entry;
+	/** Separator entry button */
+	ui_pbutton_t *sep_entry;
+	/** Move entry up button */
+	ui_pbutton_t *up_entry;
+	/** Move entry down button */
+	ui_pbutton_t *down_entry;
+} startmenu_t;
+
+/** Start menu entry */
+typedef struct startmenu_entry {
+	/** Containing start menu configuration tab */
+	struct startmenu *startmenu;
+	/** Backing entry */
+	smenu_entry_t *entry;
+	/** List entry */
+	ui_list_entry_t *lentry;
+} startmenu_entry_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskbar-cfg/types/taskbar-cfg.h
===================================================================
--- uspace/app/taskbar-cfg/types/taskbar-cfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar-cfg/types/taskbar-cfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar-cfg
+ * @{
+ */
+/**
+ * @file Taskbar configuration utility (UI) types
+ */
+
+#ifndef TYPES_TASKBAR_CFG_H
+#define TYPES_TASKBAR_CFG_H
+
+#include <tbarcfg/tbarcfg.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/tabset.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+
+/** Taskbar configuration utility (UI) */
+typedef struct taskbar_cfg {
+	/** Taskbar configuration */
+	tbarcfg_t *tbarcfg;
+	/** UI */
+	ui_t *ui;
+	/** Containing window */
+	ui_window_t *window;
+	/** Fixed layout */
+	ui_fixed_t *fixed;
+	/** Tab set */
+	ui_tab_set_t *tabset;
+	/** Start menu configuration tab */
+	struct startmenu *startmenu;
+} taskbar_cfg_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskbar/clock.c
===================================================================
--- uspace/app/taskbar/clock.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar/clock.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,347 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar
+ * @{
+ */
+/** @file Taskbar clock.
+ *
+ * Displays the current time in an inset frame.
+ */
+
+#include <errno.h>
+#include <gfx/render.h>
+#include <gfx/text.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <task.h>
+#include <ui/control.h>
+#include <ui/paint.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include "clock.h"
+
+static void taskbar_clock_ctl_destroy(void *);
+static errno_t taskbar_clock_ctl_paint(void *);
+static ui_evclaim_t taskbar_clock_ctl_kbd_event(void *, kbd_event_t *);
+static ui_evclaim_t taskbar_clock_ctl_pos_event(void *, pos_event_t *);
+static void taskbar_clock_timer(void *);
+
+/** Taskbar clock control ops */
+static ui_control_ops_t taskbar_clock_ctl_ops = {
+	.destroy = taskbar_clock_ctl_destroy,
+	.paint = taskbar_clock_ctl_paint,
+	.kbd_event = taskbar_clock_ctl_kbd_event,
+	.pos_event = taskbar_clock_ctl_pos_event
+};
+
+/** Create taskbar clock.
+ *
+ * @param window Containing window
+ * @param rclock Place to store pointer to new clock
+ * @return EOK on success or an error code
+ */
+errno_t taskbar_clock_create(ui_window_t *window, taskbar_clock_t **rclock)
+{
+	taskbar_clock_t *clock;
+	errno_t rc;
+
+	clock = calloc(1, sizeof(taskbar_clock_t));
+	if (clock == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&taskbar_clock_ctl_ops, (void *)clock,
+	    &clock->control);
+	if (rc != EOK) {
+		free(clock);
+		return rc;
+	}
+
+	clock->timer = fibril_timer_create(NULL);
+	if (clock->timer == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	fibril_mutex_initialize(&clock->lock);
+	fibril_condvar_initialize(&clock->timer_done_cv);
+	fibril_timer_set(clock->timer, 1000000, taskbar_clock_timer, clock);
+
+	clock->window = window;
+	*rclock = clock;
+	return EOK;
+error:
+	ui_control_delete(clock->control);
+	free(clock);
+	return rc;
+}
+
+/** Destroy taskbar clock.
+ *
+ * @param clock Taskbar clock
+ */
+void taskbar_clock_destroy(taskbar_clock_t *clock)
+{
+	/*
+	 * Signal to the timer that we are cleaning up. If the timer handler
+	 * misses it and sets the timer again, we will clear that active
+	 * timer and be done (and if we were even slower and the timer
+	 * fired again, it's the same situation as before.
+	 */
+	fibril_mutex_lock(&clock->lock);
+	clock->timer_cleanup = true;
+	fibril_mutex_unlock(&clock->lock);
+
+	/* If we catch the timer while it's active, there's nothing to do. */
+	if (fibril_timer_clear(clock->timer) != fts_active) {
+		/* Need to wait for timer handler to finish */
+		fibril_mutex_lock(&clock->lock);
+		while (clock->timer_done == false)
+			fibril_condvar_wait(&clock->timer_done_cv, &clock->lock);
+		fibril_mutex_unlock(&clock->lock);
+	}
+
+	fibril_timer_destroy(clock->timer);
+	ui_control_delete(clock->control);
+	free(clock);
+}
+
+static errno_t taskbar_clock_get_text(taskbar_clock_t *clock, char *buf,
+    size_t bsize)
+{
+	struct timespec ts;
+	struct tm tm;
+	errno_t rc;
+
+	getrealtime(&ts);
+	rc = time_utc2tm(ts.tv_sec, &tm);
+	if (rc != EOK)
+		return rc;
+
+	snprintf(buf, bsize, "%02d:%02d:%02d", tm.tm_hour, tm.tm_min,
+	    tm.tm_sec);
+	return EOK;
+}
+
+/** Paint taskbar clock.
+ *
+ * @param clock Taskbar clock
+ */
+errno_t taskbar_clock_paint(taskbar_clock_t *clock)
+{
+	gfx_context_t *gc = ui_window_get_gc(clock->window);
+	ui_resource_t *res = ui_window_get_res(clock->window);
+	ui_t *ui = ui_window_get_ui(clock->window);
+	char buf[10];
+	gfx_text_fmt_t fmt;
+	gfx_coord2_t pos;
+	gfx_rect_t irect;
+	errno_t rc;
+
+	if (!ui_is_textmode(ui)) {
+		/* Paint frame */
+		rc = ui_paint_inset_frame(res, &clock->rect, &irect);
+		if (rc != EOK)
+			goto error;
+	} else {
+		irect = clock->rect;
+	}
+
+	rc = gfx_set_color(gc, ui_resource_get_wnd_face_color(res));
+	if (rc != EOK)
+		goto error;
+
+	/* Fill background */
+	rc = gfx_fill_rect(gc, &irect);
+	if (rc != EOK)
+		goto error;
+
+	pos.x = (irect.p0.x + irect.p1.x) / 2;
+	pos.y = (irect.p0.y + irect.p1.y) / 2;
+
+	gfx_text_fmt_init(&fmt);
+	fmt.font = ui_resource_get_font(res);
+	fmt.color = ui_resource_get_wnd_text_color(res);
+	fmt.halign = gfx_halign_center;
+	fmt.valign = gfx_valign_center;
+
+	rc = taskbar_clock_get_text(clock, buf, sizeof(buf));
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_puttext(&pos, &fmt, buf);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_update(gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Handle taskbar clock keyboard event.
+ *
+ * @param clock Taskbar clock
+ * @param event Keyboard event
+ * @return ui_claimed iff event was claimed
+ */
+ui_evclaim_t taskbar_clock_kbd_event(taskbar_clock_t *clock, kbd_event_t *event)
+{
+	return ui_unclaimed;
+}
+
+/** Handle taskbar clock position event.
+ *
+ * @param clock Taskbar clock
+ * @param event Position event
+ * @return ui_claimed iff event was claimed
+ */
+ui_evclaim_t taskbar_clock_pos_event(taskbar_clock_t *clock, pos_event_t *event)
+{
+	gfx_coord2_t pos;
+
+	pos.x = event->hpos;
+	pos.y = event->vpos;
+	if (!gfx_pix_inside_rect(&pos, &clock->rect))
+		return ui_unclaimed;
+
+	return ui_claimed;
+}
+
+/** Get base control for taskbar clock.
+ *
+ * @param clock Taskbar clock
+ * @return Base UI control
+ */
+ui_control_t *taskbar_clock_ctl(taskbar_clock_t *clock)
+{
+	return clock->control;
+}
+
+/** Set taskbar clock rectangle.
+ *
+ * @param clock Taskbar clock
+ * @param rect Rectangle
+ */
+void taskbar_clock_set_rect(taskbar_clock_t *clock, gfx_rect_t *rect)
+{
+	gfx_rect_t irect;
+
+	clock->rect = *rect;
+
+	irect.p0.x = clock->rect.p0.x + 1;
+	irect.p0.y = clock->rect.p0.y + 1;
+	irect.p1.x = clock->rect.p1.x;
+	irect.p1.y = clock->rect.p1.y - 1;
+
+	(void)irect;
+}
+
+/** Destroy clock control.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ */
+void taskbar_clock_ctl_destroy(void *arg)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	taskbar_clock_destroy(clock);
+}
+
+/** Paint taskbar clock control.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ * @return EOK on success or an error code
+ */
+errno_t taskbar_clock_ctl_paint(void *arg)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	return taskbar_clock_paint(clock);
+}
+
+/** Handle taskbar clock control keyboard event.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t taskbar_clock_ctl_kbd_event(void *arg, kbd_event_t *event)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	return taskbar_clock_kbd_event(clock, event);
+}
+
+/** Handle taskbar clock control position event.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t taskbar_clock_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	return taskbar_clock_pos_event(clock, event);
+}
+
+/** Taskbar clock timer handler.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ */
+static void taskbar_clock_timer(void *arg)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+	ui_t *ui;
+
+	ui = ui_window_get_ui(clock->window);
+	ui_lock(ui);
+
+	fibril_mutex_lock(&clock->lock);
+	if (!ui_is_suspended(ui_window_get_ui(clock->window)))
+		(void) taskbar_clock_paint(clock);
+
+	if (!clock->timer_cleanup) {
+		fibril_timer_set(clock->timer, 1000000, taskbar_clock_timer,
+		    clock);
+	} else {
+		/* Acknowledge timer cleanup */
+		clock->timer_done = true;
+		fibril_condvar_signal(&clock->timer_done_cv);
+	}
+
+	fibril_mutex_unlock(&clock->lock);
+	ui_unlock(ui);
+}
+
+/** @}
+ */
Index: uspace/app/taskbar/clock.h
===================================================================
--- uspace/app/taskbar/clock.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar/clock.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar
+ * @{
+ */
+/**
+ * @file Taskbar clock
+ */
+
+#ifndef CLOCK_H
+#define CLOCK_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <ui/control.h>
+#include <ui/window.h>
+#include <stdbool.h>
+#include "types/clock.h"
+
+extern errno_t taskbar_clock_create(ui_window_t *, taskbar_clock_t **);
+extern void taskbar_clock_destroy(taskbar_clock_t *);
+extern errno_t taskbar_clock_paint(taskbar_clock_t *);
+extern ui_evclaim_t taskbar_clock_kbd_event(taskbar_clock_t *, kbd_event_t *);
+extern ui_evclaim_t taskbar_clock_pos_event(taskbar_clock_t *, pos_event_t *);
+extern ui_control_t *taskbar_clock_ctl(taskbar_clock_t *);
+extern void taskbar_clock_set_rect(taskbar_clock_t *, gfx_rect_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskbar/doc/doxygroups.h
===================================================================
--- uspace/app/taskbar/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,4 @@
+/** @addtogroup taskbar taskbar
+ * @brief Taskbar
+ * @ingroup apps
+ */
